/**************************** Pametni alarmni sustav = kontaktni senzor + GSM/GPRS shiled **************************

Predmet:      Sustavi za praćenje i vođenje procesa
Projekt:      Pametni alarmni sustav
Autor:        Matej Hržić
JMBAG:        0036448996
Sveučilište:  Fakultet elektrotehnike i računarstva, 10000 Zagreb

********************************************************************************************************************/

#include <SoftwareSerial.h>         // library za serijsku komunikaciju s GSM shiledom
SoftwareSerial  Sim900Serial(2, 3); // definiranje Rx i Tx pinova na GSM shiledu 

int analogPin1 = 0;     // broj pina na koji spajamo senzor = A0
int analogPin2 = 1;     // broj pina na koji spajamo senzor = A1
int val1 = 0;           // varijabla u koju zapisujemo vrijednost ocitanja senzora
                        // definiramo je kao 0 na pocetku (smanjimo utjecaj suma)
int val2 = 0;           // varijabla u koju zapisujemo vrijednost ocitanja senzora
                        // definiramo je kao 0 na pocetku (smanjimo utjecaj suma)
int izlaz1 = 12;        // obavijest o detekciji saljemo na digitalni pin D13
int izlaz2 = 8;         // obavijest o detekciji saljemo na digitalni pin D12

int POWER = 7;          // broj pina preko kojeg palimo GSM modul

void setup(){
  
  pinMode(izlaz1, OUTPUT);              // definiramo izlaz1 kao OUTPUT       
  pinMode(izlaz2, OUTPUT);              // definiramo izlaz2 kao OUTPUT
  pinMode(POWER, OUTPUT);               // definiramo digitalPin kao OUTPUT
  
  // definiranje parametara GSM veze
  Sim900Serial.begin(115200);              // the GPRS baud rate  
  delay(2000);
  Sim900Serial.println("AT+IPR=19200");    // Set the baud rate
  delay(500);
  Sim900Serial.begin(19200);               // the GPRS baud rate   
  delay(1000);
  
  // ukljucivanje GSM modula
  digitalWrite(POWER, HIGH);
  delay(3000);
  digitalWrite(POWER, LOW);
  delay(1000);
  
  Serial.begin(9600);          // ostvarujemo serijsku vezu da mozemo pratiti rezultate na serial monitoru
  Serial.println(" ");
  Serial.print("********************** Pametni alarmni sustav **********************\n");
  Serial.println(" ");
}

void loop(){

  val1 = analogRead(analogPin1);                      // ocitavamo vrijednost sa senzora
  
  val2 = analogRead(analogPin2);                      // ocitavamo vrijednost sa senzora
 
// definiranje uvjeta detekcije

    if(val1 < 600 && val2 < 600){
        
        digitalWrite(izlaz1, HIGH);                   // prijavi detekciju -> izlaz1 postavi u stanje HIGH
        digitalWrite(izlaz2, HIGH);                   // prijavi detekciju -> izlaz2 postavi u stanje HIGH
        
        Serial.print("Ocitanje prvog senzora: ");     // ispisujemo njegovu vrijednost na serial monitoru
        Serial.print("==> POZITIVNO!");
        Serial.print("   Ocitanje drugog senzora: "); // ispisujemo njegovu vrijednost na serial monitoru
        Serial.println("==> POZITIVNO!");
        Sim900Serial.println("ATD00385994900405;");   // definiramo broj koji zelimo nazvati "ATD+broj;"
                                                      // +broj definiramo u standardnom obliku
                                                      // za Hrvatsku 00385*********
        delay(20000);                                 // ukoliko dode do detekcije drzi izlaz  HIGH 20sec
        Sim900Serial.println("ATH");                  // zavrsi poziv
      }    
    
    if(val1 < 600 && !(val1 < 600 && val2 < 600)){
        digitalWrite(izlaz1, HIGH);                   // prijavi detekciju -> izlaz1 postavi u stanje HIGH
        
        Serial.print("Ocitanje prvog senzora: ");     // ispisujemo njegovu vrijednost na serial monitoru
        Serial.println("==> POZITIVNO!");
        
        Sim900Serial.println("ATD00385994900405;");   // definiramo broj koji zelimo nazvati "ATD+broj;"
                                                      // +broj definiramo u standardnom obliku
                                                      // za Hrvatsku 00385*********
        delay(20000);                                 // ukoliko dode do detekcije drzi izlaz  HIGH 20sec
        Sim900Serial.println("ATH");                  // zavrsi poziv
      }
     
    if(val2 < 600  && !(val1 < 600 && val2 < 600)){
        digitalWrite(izlaz2, HIGH);                   // prijavi detekciju -> izlaz2 postavi u stanje HIGH
        Serial.print("Ocitanje drugog senzora: ");    // ispisujemo njegovu vrijednost na serial monitoru
        Serial.println("==> POZITIVNO!");
        Sim900Serial.println("ATD00385994900405;");   // definiramo broj koji zelimo nazvati "ATD+broj;"
                                                      // +broj definiramo u standardnom obliku
                                                      // za Hrvatsku 00385*********
        delay(20000);                                 // ukoliko dode do detekcije drzi izlaz  HIGH 20sec
        Sim900Serial.println("ATH");                  // zavrsi poziv
      }
      
    else{                                             // ako ocitanje sa senzora nije dovoljno da bi detektirali
                                                      // nezeljenog gosta
      digitalWrite(izlaz1, LOW);                      // postavi izlaz1 kao LOW
      Serial.print("Ocitanje prvog senzora: ");       // ispisujemo njegovu vrijednost na serial monitoru
      Serial.print("==> negativno.");
    
      digitalWrite(izlaz2, LOW);                      // postavi izlaz2 kao LOW
      Serial.print("    Ocitanje drugog senzora: ");  // ispisujemo njegovu vrijednost na serial monitoru
      Serial.println("==> negativno.");
  }
  
  delay(100);                                         // vrijednosta sa senzora uzimamo svakih 100ms
}
